function castVote(rank) {
	try {
	// branch for native XMLHttpRequest object
	req = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP");
	req.onreadystatechange = handleResponse;
	req.open("GET","http://localhost:8080/calcVotes.jsp?rank="+rank, true);
	req.send(null);
	} catch (e) {
		alert("Sorry, your browser is not AJAX-enabled!");
	}
}

function handleResponse() {
	if (req.readyState == 4) {
		if (req.status == 200) {
			response = req.responseXML.documentElement;
			table=document.getElementById("votes");
			linux='Linux:<b> '+response.getElementsByTagName('linux')[0].firstChild.data+'</b>';
			windows='Windows:<b> '+response.getElementsByTagName('windows')[0].firstChild.data+'</b>';
			solaris='Solaris:<b> '+response.getElementsByTagName('solaris')[0].firstChild.data+'</b>';
			cares='Who Cares:<b> '+response.getElementsByTagName('cares')[0].firstChild.data+'</b>';

			table.rows[0].cells[0].innerHTML='<p align="center"><font size="2" color="#000080">Vote Results</font></p>';
			table.rows[1].cells[0].innerHTML=linux;
			table.rows[2].cells[0].innerHTML=windows;
			table.rows[3].cells[0].innerHTML=solaris;
			table.rows[4].cells[0].innerHTML=cares;
		} else
			alert("There was a problem retrieving the response:\n" + req.statusText);
	} 
}